/*
** ###################################################################
**     This code is generated by the Device Initialization Tool.
**     It is overwritten during code generation.
**     USER MODIFICATION ARE PRESERVED ONLY INSIDE INTERRUPT SERVICE ROUTINES 
**                                                 OR EXPLICITLY MARKED SECTIONS
**
**     Project   : Dotyk_tlacitka_v1
**     Processor : MC68HC908QY4CDT
**     Version   : Bean 01.079, Driver 01.00, CPU db: 2.87.145
**     Datasheet : MC68HC908QY4/D Rev. 5 07/2005, MC68HLC908QY4/D Rev. 3 07/2005
**     Date/Time : 28.11.2009, 20:27
**     Abstract  :
**         This bean "MC68HC908QY4_DT" provides initialization of the 
**         CPU core and shared peripherals.
**     Settings  :
**         Clock setting
**             Internal clock      : 12800 kHz
**             Initialization interrupt priority : 1
**             Stop instruction enabled : no
**             LVI module          : yes
**
**             Source clock        : Internal Clock
**             Internal bus clock  : 3.2 MHz
**     Contents  :
**         Function "MCU_init" initializes selected peripherals
**
**     (c) Copyright UNIS, spol. s r.o. 1997-2006
**     UNIS, spol s r.o.
**     Jundrovska 33
**     624 00 Brno
**     Czech Republic
**     http      : www.processorexpert.com
**     mail      : info@processorexpert.com
** ###################################################################
*/

/* MODULE MCUinit */

#include <MC68HC908QY4.h>              /* I/O map for MC68HC908QY4CDT */
#include "MCUinit.h"

/* User declarations and definitions */
#include "DotykTlac.h"
extern byte g_ucSTATUS_1;
extern byte g_uc20msClockTicks;
/* End of user declarations and definitions */


/*
** ===================================================================
**     Method      :  MCU_init (bean MC68HC908QY4_DT)
**
**     Description :
**         Device initialization code for selected peripherals.
** ===================================================================
*/
void MCU_init(void)
{

/*** ### MC68HC908QY4_DT "Cpu" init code ... ***/
/*** PE initialization code after reset ***/
/* System clock initialization */

  /* Common initialization of the write once registers */
  /* CONFIG1: COPRS=0,LVISTOP=0,LVIRSTD=0,LVIPWRD=0,LVI5OR3=1,SSREC=0,STOP=0,COPD=1 */
  CONFIG1 = 0x09;                                      
  /* CONFIG2: IRQPUD=0,IRQEN=0,OSCOPT1=0,OSCOPT0=0,RSTEN=0 */
  CONFIG2 = 0x00;                                      
  OSCTRIM = *(unsigned char*far)0xFFC0; /* Initialize OSCTRIM register from a non volatile memory */
  /* Common initialization of the CPU registers */
  /* PTAPUE: OSC2EN=0,PTAPUE0=0 */
  PTAPUE &= (unsigned char)~0x81;                     
  /* ### Init_TIM init code */
  /* TSC: TOF=0,TOIE=0,TSTOP=1,TRST=1,PS2=0,PS1=0,PS0=0 */
  TSC = 0x30;                          /* Stop and reset counter */
  TCH0 = 0x0C80;                       /* Compare 0 value setting */
  (void)(TSC0 == 0);                   /* Channel 0 int. flag clearing (First part) */
  /* TSC0: CH0F=0,CH0IE=0,MS0B=1,MS0A=0,ELS0B=1,ELS0A=0,TOV0=1,CH0MAX=0 */
  TSC0 = 0x2A;                         /* Int. flag clearing (2nd part) and  channel contr. register setting */
  TMOD = 0xFA00;                       /* Period value setting */
  (void)(TSC == 0);                    /* Overflow int. flag clearing (first part) */
  /* TSC: TOF=0,TOIE=1,TSTOP=0,TRST=0,PS2=0,PS1=0,PS0=0 */
  TSC = 0x40;                          /* Int. flag clearing (2nd part) and timer contr. register setting */
  /* ### Init_GPIO init code */
  /* PTA: PTA5=0,PTA3=0,PTA1=0 */
  PTA &= (unsigned char)~0x2A;                     
  /* PTAPUE: PTAPUE5=0,PTAPUE4=1,PTAPUE3=0,PTAPUE2=1,PTAPUE1=0 */
  PTAPUE = (PTAPUE & (unsigned char)~0x2A) | (unsigned char)0x14;
  /* DDRA: DDRA5=1,DDRA4=0,DDRA3=1,DDRA1=1 */
  DDRA = (DDRA & (unsigned char)~0x10) | (unsigned char)0x2A;
  /* ### Init_COP init code */
  COPCTL = 0xFF;                       /* Clear WatchDog counter */
  /* ### Init_GPIO init code */
  /* PTB: PTB7=0,PTB6=0,PTB5=0,PTB4=0,PTB3=0,PTB2=0,PTB1=0,PTB0=0 */
  PTB = 0x00;                                      
  /* PTBPUE: PTBPUE7=0,PTBPUE6=0,PTBPUE5=0,PTBPUE4=0,PTBPUE3=0,PTBPUE2=0,PTBPUE1=0,PTBPUE0=0 */
  PTBPUE = 0x00;                                      
  /* DDRB: DDRB7=1,DDRB6=1,DDRB5=1,DDRB4=1,DDRB3=1,DDRB2=1,DDRB1=1,DDRB0=1 */
  DDRB = 0xFF;                                      
  /* ### */
 /* Common peripheral initialization - ENABLE */
  /* KBSCR: ACKK=1,IMASKK=1 */
  KBSCR |= (unsigned char)0x06;                               
  asm CLI;                             /* Enable interrupts */
} /*MCU_init*/


/*
** ===================================================================
**     Interrupt handler : OnTimerOverflow
**
**     Description :
**         User interrupt service routine. 
**     Parameters  : None
**     Returns     : Nothing
** ===================================================================
*/
__interrupt void OnTimerOverflow(void)
{
   TSC &= ~TSC_TOF_MASK;      /* Acknowledge interrupt  */

//   if( ++g_uc20msClockTicks >= CLOCK_20MS_TICK_COUNTER_LIMIT )
  // {
      g_ucSTATUS_1 |= S1M_20ms_TIMER_TICK;
//      g_uc20msClockTicks = 0;   
 //  }                           
}
/* end of OnTimerOverflow */



/* Initialization of the CPU registers in FLASH */



#ifndef UNASSIGNED_ISR
  #define UNASSIGNED_ISR 0xFFFF        /* Unassigned interrupt service routine */
#endif

extern void _Startup(void);            /* reset interrupt service routine */

void (* const _vect[])() @0xFFDE = {   // Interrupt vector table
        UNASSIGNED_ISR,                /* Int.no.  0 INT_ADC (at FFDE)               Unassigned */
        UNASSIGNED_ISR,                /* Int.no.  1 INT_KBI (at FFE0)               Unassigned */
        UNASSIGNED_ISR,                /* Int.no.  2 Reserved2 (at FFE2)             Unassigned */
        UNASSIGNED_ISR,                /* Int.no.  3 Reserved3 (at FFE4)             Unassigned */
        UNASSIGNED_ISR,                /* Int.no.  4 Reserved4 (at FFE6)             Unassigned */
        UNASSIGNED_ISR,                /* Int.no.  5 Reserved5 (at FFE8)             Unassigned */
        UNASSIGNED_ISR,                /* Int.no.  6 Reserved6 (at FFEA)             Unassigned */
        UNASSIGNED_ISR,                /* Int.no.  7 Reserved7 (at FFEC)             Unassigned */
        UNASSIGNED_ISR,                /* Int.no.  8 Reserved8 (at FFEE)             Unassigned */
        UNASSIGNED_ISR,                /* Int.no.  9 Reserved9 (at FFF0)             Unassigned */
        OnTimerOverflow,               /* Int.no. 10 INT_TIMOvr (at FFF2)            Used */
        UNASSIGNED_ISR,                /* Int.no. 11 INT_TIMCH1 (at FFF4)            Unassigned */
        UNASSIGNED_ISR,                /* Int.no. 12 INT_TIMCH0 (at FFF6)            Unassigned */
        UNASSIGNED_ISR,                /* Int.no. 13 Reserved13 (at FFF8)            Unassigned */
        UNASSIGNED_ISR,                /* Int.no. 14 INT_IRQ (at FFFA)               Unassigned */
        UNASSIGNED_ISR,                /* Int.no. 15 INT_SWI (at FFFC)               Unassigned */
        _Startup                       /* Int.no. 16 INT_RESET (at FFFE)             Reset vector */
};


/* END MCUinit */

/*
** ###################################################################
**
**     This file was created by UNIS Processor Expert 3.01 [03.92]
**     for the Freescale HC08 series of microcontrollers.
**
** ###################################################################
*/
